<!-- 选择标准装置 -->
<script lang="ts" setup name="SelectStandardDialog">
import { ElMessage } from 'element-plus'
import type { Ref } from 'vue'
import { ref } from 'vue'
import dayjs from 'dayjs'
import type { DateModelType } from 'element-plus'
import { getStandardList } from '@/api/equipment/standard/book'
import type { TableColumn } from '@/components/NormalTable/table_interface'
import { SCHEDULE } from '@/utils/scheduleDict'
import { getDeptTreeList } from '@/api/system/dept'
import { getStaffList } from '@/api/resource/register'
import { toTreeList } from '@/utils/structure'
import type { deptType } from '@/global'
import { getDictByCode } from '@/api/system/dict'
import useUserStore from '@/store/modules/user'
const props = defineProps({
  isMulti: { // 是否多选
    type: Boolean,
    default: false, // 默认单选
  },
})
// 用户信息
const emits = defineEmits(['confirm'])
const user = useUserStore()
const dialogFormVisible = ref(false)
const standardId = ref('') // 标准装置id
// 查询条件
const listQuery = ref({
  approvalStatus: '0', // 审批状态
  deptId: user.deptId, // 部门id
  formId: SCHEDULE.STANDARD_BOOK_APPROVAL, // formid
  standardName: '', // 标准装置名称
  storageLocation: '', // 存放地点
  technologyFileName: '', // 依据的技术文件
  offset: 1,
  limit: props.isMulti ? 5 : 20,
})
// 多选选中的内容
const checkoutList = ref([])
const loadingTable = ref(false)
const list = ref([]) // 表格数据
const total = ref(0)
const columns = ref<TableColumn[]>([
  { text: '标准代码', value: 'standardNo', align: 'center' },
  { text: '计量标准装置名称', value: 'standardName', align: 'center' },
  { text: '存放地点', value: 'storageLocationName', align: 'center' },
  { text: '测量范围', value: 'measureRange', align: 'center' },
  { text: '不确定度或允许误差极限或准确度等级', value: 'uncertainty', align: 'center' },
  { text: '建标日期', value: 'date', align: 'center', width: '120' },
  { text: '最近复查日期', value: 'lastReviewDate', align: 'center', width: '120' },
  { text: '计量标准证书号', value: 'standardCertNo', align: 'center' },
  { text: '检定或校准项目', value: 'measureItem', align: 'center' },
])
const dateRange = ref<[DateModelType, DateModelType]>(['', ''])// 筛选时间段数据

// -----------------------------------------字典--------------------------------------------------------------
const storageLocationList = ref({}) as any // 存放地点{1: 新建}
// 查询字典
const getDict = async () => {
  // 存放地点
  getDictByCode('bizStorageLocation').then((response) => {
    storageLocationList.value = response.data
  })
}
// --------------------------------------------------------------------------------------------

// 数据查询
function fetchData(isNowPage = false) {
  loadingTable.value = true
  if (!isNowPage) {
    // 是否显示当前页，否则跳转第一页
    listQuery.value.offset = 1
  }
  getStandardList(listQuery.value).then((response) => {
    list.value = response.data.rows.map((item: { lastReviewDate: string; agreementAmount: number }) => {
      return {
        ...item,
        lastReviewDate: item.lastReviewDate ? dayjs(item.lastReviewDate).format('YYYY-MM-DD') : item.lastReviewDate, // 最近复查日期
      }
    })
    total.value = parseInt(response.data.total)
    loadingTable.value = false
  }).catch(() => {
    loadingTable.value = false
  })
}
// 重置
const clearList = () => {
  listQuery.value = {
    approvalStatus: '0', // 审批状态
    deptId: user.deptId, // 部门id
    formId: SCHEDULE.STANDARD_BOOK_APPROVAL, // formid
    standardName: '', // 标准装置名称
    storageLocation: '', // 存放地点
    technologyFileName: '', // 依据的技术文件
    offset: 1,
    limit: props.isMulti ? 5 : 20,
  }
  dateRange.value = ['', '']
  fetchData()
}
// 搜索
const search = () => {
  fetchData(true)
}
// 多选选中
const handleSelectionChange = (val: any) => {
  checkoutList.value = val
}
// 页数发生变化后的操作，可能是页码变化，可能是每页容量变化，此函数必写
const changePage = (val: { size?: number;page?: number }) => {
  if (val && val.size) {
    listQuery.value.limit = val.size
  }
  if (val && val.page) {
    listQuery.value.offset = val.page
  }
  search()
}
// 点击确定
const confirmSelect = () => {
  if (!checkoutList.value.length) {
    ElMessage.warning('请选择设备')
  }
  else {
    emits('confirm', checkoutList.value)
    dialogFormVisible.value = false
  }
}
// 取消
const resetForm = () => {
  dialogFormVisible.value = false
  clearList()
}
// 初始化
const initDialog = async (id: string) => {
  await getDict()
  dialogFormVisible.value = true
  fetchData()
}

defineExpose({ initDialog })
</script>

<template>
  <el-dialog v-if="dialogFormVisible" v-model="dialogFormVisible" title="选择设备" width="65%">
    <!-- 筛选条件 -->
    <search-area :need-clear="true" @search="search" @clear="clearList">
      <search-item>
        <el-input v-model.trim="listQuery.standardName" placeholder="标准装置名称" class="short-input" clearable />
      </search-item>
      <search-item>
        <search-item>
          <el-select
            v-model="listQuery.storageLocation"
            placeholder="存放地点"
            class="short-input"
            filterable
          >
            <el-option v-for="item in storageLocationList" :key="item.id" :label="item.name" :value="item.value" />
          </el-select>
        </search-item>
        <!-- <search-item>
          <el-input v-model.trim="listQuery.technologyFileName" placeholder="依据的技术文件" class="short-input" clearable />
        </search-item> -->
      </search-item>
    </search-area>

    <!-- 查询结果Table显示 -->
    <div style="padding: 12px;">
      <normal-table
        :data="list"
        :total="total"
        :columns="columns"
        :query="listQuery"
        is-showmulti-select
        :list-loading="loadingTable"
        :is-multi="props.isMulti"
        :height="260"
        :page-sizes="props.isMulti ? [5] : [20]"
        @change="changePage"
        @multi-select="handleSelectionChange"
      >
        <!-- 序号 -->
        <template #preColumns>
          <el-table-column label="#" width="55" align="center" fixed>
            <template #default="scope">
              {{ (listQuery.offset - 1) * listQuery.limit + scope.$index + 1 }}
            </template>
          </el-table-column>
        </template>
      </normal-table>
    </div>
    <template #footer>
      <span class="dialog-footer">
        <el-button type="primary" @click="confirmSelect">确认</el-button>
        <el-button @click="resetForm">
          取消
        </el-button>
      </span>
    </template>
  </el-dialog>
</template>

<style lang="scss" scoped>
:deep(.el-radio__label) {
  display: none;
}
</style>
